from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName

from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent

# AT & LinguaPlone support?
try:
   from Products.LinguaPlone.public import *
except ImportError:
   from Products.Archetypes.public import *

from Products.Archetypes.interfaces.base import *

from field import *
from widget import *
from config import *

__all__ = ["DataMergeContent"]

class DataMergeContent(BaseContent):
   """public action content"""

   meta_type = portal_type = archetype_name = "Data Merge Content"
   global_allow = 1
   allow_discussion = 0

   schema = BaseContent.schema.copy() + Schema((

      DataMergeStringField("datamerge_stringtest",
         data_method ="compileMergeData",
         separators = "[]",
         widget=StringWidget(
            label="Data merge string field",
            description="This field is a DataMergeStringField that uses StringWidget"
         )
      ),

      DataMergeTextField("datamerge_texttest",
         data_method ="compileMergeData",
         separators = "[]",
         widget=RichWidget(
            label="Data merge text field",
            default_output_type = "text/plain",
            description="This field is a DataMergeTextField that uses TextAreaWidget"
         )
      ),

      StringField("datamerge_stringfieldwidgettest",
         widget=DataMergeStringWidget(
            data_method="compileMergeData",
            separators="[]",
            label="StringField w/ DataMergeStringWidget",
            description="This field is a string field that uses a data merge string widget"
         )
      ),

      TextField("datamerge_textfieldwidgettest",
         widget=DataMergeRichWidget(
            data_method="compileMergeData",
            separators="[]",
            label="TextField w/ DataMergeRichWidget",
            description="This field is a text field that uses data merge rich text widget"
         )
      )
   ))

   def compileMergeData(self):
      data = {"message":"Hello World!", "count":1234.0}
      try:
         data.update(self.getMergeData())
      except:
         pass

      return data

registerType(DataMergeContent)
