from config import *


def checkProperties(item, instance, methodname, separators):

   name = item.__class__.__name__

   if not methodname:
      raise Exception("%s does not have a 'data_method' property!?" % name)

   if not separators:
      raise Exception("%s does not have a 'separators' property!?" % name)

   datamethod = ""

   try:
      datamethod=getattr(instance, methodname)
   except AttributeError, e:
      raise Exception("%s data_method '%s' cannot be found!?" % (name, methodname))

   if not callable(datamethod):
      raise Exception("%s data_method '%s' is not a valid callable!?" % (name, methodname))


def fillData(content, data, separators):
   "replace field names with data values"

   expanded = []

   l_sep, r_sep = separators
   cursor = 0

   while content:
      l_loc = content.find(l_sep,cursor)
      r_loc = content.find(r_sep,l_loc)
      if l_loc != -1 and r_loc !=-1:
         expanded.append(content[cursor:l_loc])
         fieldname = content[l_loc+1:r_loc]

         if ' ' in fieldname:
            raise Exception("Invalid field name: '%s'!" % fieldname)

         try:
            expanded.append(str(data[fieldname]))
         except:
            expanded.append(l_sep + "no data for '%s'" % fieldname + r_sep)

         cursor = r_loc + 1

      else:
         expanded.append(content[cursor:])
         break

   return "".join(expanded)
