from AccessControl import ClassSecurityInfo

# AT & LinguaPlone support?
try:
   from Products.LinguaPlone.public import *
except ImportError:
   from Products.Archetypes.public import *
   
from Products.Archetypes.Registry import registerWidget, registerPropertyType

from config import *
from util import fillData, checkProperties

__all__ = ("DataMergeStringWidget", "DataMergeRichWidget")

class DataMergeStringWidget(StringWidget):
   _properties = StringWidget._properties.copy()
   _properties.update(
      {
       'data_method' : "compileMergeData",
       'separators': "[]"
      }
   )
   security = ClassSecurityInfo()


   def bootstrap(self,instance):
      "get instance"
      self._instance = instance


   security.declarePublic('populateProps')
   def populateProps(self, field):
      """This is called when the field is created."""
      name = field.getName()
      if not self.label:
         self.label = capitalize(name)
      
      self._field = field
     
     
   security.declarePublic('dataMerge')
   def dataMerge(self):
      "merge"

      checkProperties(self, self._instance, self.data_method, self.separators)

      original = ObjectField.get(self, self._instance)
      return fillData(original, getattr(self._instance,self.data_method)(), separators=self.separators)


class DataMergeRichWidget(RichWidget):
   _properties = RichWidget._properties.copy()
   _properties.update(
      {
       'data_method' : "compileMergeData",
       'separators': "[]"
      }
   )
   security = ClassSecurityInfo()


   def bootstrap(self,instance):
      "get instance"
      self._instance = instance


   security.declarePublic('populateProps')
   def populateProps(self, field):
      """This is called when the field is created."""
      name = field.getName()
      if not self.label:
         self.label = capitalize(name)
      
      self._field = field
     
     
   security.declarePublic('dataMerge')
   def dataMerge(self):
      "merge"

      checkProperties(self, self._instance, self.data_method, self.separators)

      original = ObjectField.get(self, self._instance)
      return fillData(original, getattr(self._instance,self.data_method)(), separators=self.separators)
  

  
registerWidget(DataMergeStringWidget,
               title='DataMerge StringWidget',
               description="Expands fields with values from data_method",
               used_for=('Products.Archetypes.Field.StringField',)
)

registerWidget(DataMergeRichWidget,
               title='DataMerge RichWidget',
               description="Expands fields with values from data_method",
               used_for=('Products.Archetypes.Field.TextField',)
)
   
registerPropertyType('data_method', 'string', DataMergeStringWidget)
registerPropertyType('separators', 'integer', DataMergeStringWidget)
registerPropertyType('data_method', 'string', DataMergeRichWidget)
registerPropertyType('separators', 'integer', DataMergeRichWidget)
