import os
from cStringIO import StringIO

from Globals import package_home
from zLOG import LOG, PROBLEM
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName

from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes

from Products.eCampaigning.config import *

#import Products.eCampaigning.workflow as action_workflow


def applyGenericSetupProfile(portal, out):
    try:
       setup_tool = getToolByName(portal, 'portal_setup')
    except:
       return
    setup_tool.setImportContext('profile-eCampaigning:default')
    print >> out, "Applying the generic setup profile for eCampaigning..."
    setup_tool.runAllImportSteps(purge_old=False)
    try:
        setup_tool.setImportContext('profile-CMFPlone:plone')
    except KeyError:
        # Plone 3.0 has a different profile name
        setup_tool.setImportContext('profile-Products.CMFPlone:plone')
    print >> out, "Applied the generic setup profile for eCampaigning"


# Add prop - value pairs
def addPropertySheet(self,propertysheet, properties,out):
    propstool = getToolByName(self, 'portal_properties')
    if propertysheet not in propstool.objectIds():
        propstool.manage_addPropertySheet(propertysheet,title="for customization of ecampaigning component")
        print >> out, "Added '%s' propertysheet" % propertysheet
    else:
        print >> out, "Propertysheet \"%s\" already exists in %s, not adding" % (propertysheet, propstool.getId())

    try:
        for pname in properties.keys():
           ps = getattr(propstool,propertysheet)
           p = properties[pname]
           if not ps.hasProperty(pname):
              v = ""
              for vl in p:
                 v += vl[0] + " | " + vl[1] +"\n"
              v=v.strip('\n')
              ps.manage_addProperty(pname,v,"lines")
              print >> out, "Added '%s' property" % pname
    except:
        print >> out, "Stopping adding properties to %s - problem adding %s property!!!" % (propertysheet, pname)


def install(self):
    " Register the with portal_types and friends "
    out = StringIO()
    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')
    portal_url = getToolByName(self, 'portal_url')

    # TYPES INSTALL
    installTypes(self,out,listTypes(PROJECTNAME), PROJECTNAME)

    # ADD TO PORTAL FACTORY
    factory = getToolByName(self, 'portal_factory')
    ftypes = factory.getFactoryTypes().keys()
    tlist = (
       "Campaign Action",
    )
    for t in tlist:
       if t not in ftypes:
          ftypes.append(t)
          factory.manage_setPortalFactoryTypes(listOfTypeIds = ftypes)

    print >> out, "Added %s to portal_factory" % ', '.join(tlist)

    # SKINS INSTALL (see CMFDefault/scripts/addImagesToSkinPaths.py)
    try:
        # add Filesystem Directory Views for directories in skins/
        addDirectoryViews(skinstool, SKINS_DIR, GLOBALS)
        out.write("Added directory views to portal_skins\n")
    except Exception, e:
        out.write("error adding directory views: %s\n" % e)

    # Install desired layers to all skins. Adapted from AT utils.
    for layer in COMMONLAYERS:
        for skinName in skinstool.getSkinSelections():
            path = skinstool.getSkinPath(skinName)
            path = [i.strip() for i in  path.split(',')]
            try:
                if layer not in path:
                    path.insert(path.index('custom') +1, layer)
                    out.write("Inserted %s to %s\n" % (layer, skinName))
            except ValueError:
                if layer not in path:
                    path.append(layer)
                    out.write("Appended %s to %s\n" % (layer, skinName))
            path = ','.join(path)
            skinstool.addSkinSelection(skinName, path)

    # When adding a new skin, copy base layers from BASESKIN
    if "SKINS" in globals():
        try:
            for s in SKINS:
                baselayers = skinstool.getSkinPath(name=BASESKIN)
                if baselayers[:6] == "custom":
                    baselayers = baselayers[7:]
                skinstool.addSkinSelection(s, "custom, %s, %s" % (SKINS[s], baselayers))
                out.write("Added '%s' skin\n" % s)
        except Exception, e:
            out.write("error adding skins: %s\n" % e)


    # ACTION ICONS from (category, id, icon, title) tuples
    icontool = getToolByName(self, "portal_actionicons")
    ais = (("plone","petition_signup","signup.png","Sign Up"),)
    for ai in ais:
        try:
            icontool.addActionIcon(ai[0],ai[1],ai[2],title=ai[3])
            print >> out, "added %s action icon" % ai[3]
        except Exception, e:
            print >> out, "Could not add \"%s\" action icon - probably already added" % ai[-1]


    # SITE PROPERTIES
    propstool = getToolByName(self, 'portal_properties')
    if PROPERTYSHEET not in propstool.objectIds():
        propstool.manage_addPropertySheet(PROPERTYSHEET,title="for customization of ecampaigning component")
        print >> out, "Added %s" % PROPERTYSHEET
    else:
        print >> out, "Propertysheet \"%s\" already exists in %s, no need to add" % (PROPERTYSHEET, propstool.getId())

    ecps = getattr(propstool,PROPERTYSHEET)
    try:
        for pname in PROPERTIES.keys():
           p = PROPERTIES[pname]
           v = "\n".join(["%s|%s" % (vl) for vl in p])
           #for vl in p:
           #   v += vl[0] + " | " + vl[1] +"\n"
           #v=v.strip('\n')
           ecps.manage_addProperty(pname,v,"lines")
           print >> out, "Added %s property" % pname
    except:
        pass
    
    ecprops = {
      "onlineupdates_baseurl": (URL_UPDATECHECK, "string"),
      "onlinehelp_baseurl": (URL_TOOLHELP, "string"),
      "onlinehelp_availablefor": ("\n".join(ONLINEHELP_AVAILABLEFOR), "lines"),
      "online_registry": (URL_ACTIONREGISTRY, "string"),
      "registration_requiredfields": ("\n".join(REGISTRATION_REQUIREDFIELDS), "lines"),
    }
    
    for ecprop in ecprops:
      if not ecps.hasProperty(ecprop):
        pvalue, ptype = ecprops[ecprop]
        ecps.manage_addProperty(ecprop, pvalue, ptype)
    
    # COUNTRY LISTS
    addPropertySheet(self, "country_lists",COUNTRYLISTS, out)

    # NAVTREE PORTLET CUSTOMIZATION -remove unnecessary types from portlet
    propsheet = getToolByName(self,"portal_properties").navtree_properties
    newprop = propsheet.metaTypesNotToList + NOTINNAVTREE
    propsheet.manage_changeProperties(metaTypesNotToList=newprop)
    out.write("Removed %s from navtree portlet.\n" % str(NOTINNAVTREE))

    # WORKFLOW SETTINGS
    no_flow_types = ["Action Step", "HTML Block", "Layout Element", "Field Block"]
    self.portal_workflow.setChainForPortalTypes(pt_names=no_flow_types, chain=[])

    """
    wf_tool = getToolByName(self, 'portal_workflow')
    wf_id = action_workflow.WORKFLOW_ID
    wf_title = action_workflow.WORKFLOW_ID

    if not wf_id in wf_tool.objectIds():
       #wf_tool.manage_addWorkflow('%s (%s)' % (wf_id,wf_title), '%s' % wf_id)
       wf_tool.manage_addWorkflow(wf_id, wf_id)

       # Do this after installing all workflows
       wf_tool.updateRoleMappings()

       # Now tell our custom type MyType to use this workflow
       wf_tool.setChainForPortalTypes(pt_names=['Action Edition'], chain=wf_id)

       out.write("Configured package to use %s.\n" % wf_title)
    """
    
    # CONTROLLER change action customization for action editions  - dangerous
    fctool = getToolByName(self, 'portal_form_controller')
    fctool.addFormAction(
        "content_status_modify",
        "success",
        "Action Edition",
         None,
         "traverse_to",
         "string:action_post_content_status_modify"
    )

    fctool.addFormAction(
        "createObject",
        "success",
        "Action Edition",
         None,
         "traverse_to",
         "string:action_edition_prepopulation_form"
    )

    # ADD TO KUPU resource types
    kuputool = getToolByName(self, 'kupu_library_tool')
    collections = kuputool.getPortalTypesForResourceType("collection")
    collections += ("Campaign Action", "Action Edition", "Action Step", "Layout Element")
    linkables = kuputool.getPortalTypesForResourceType("linkable")
    linkables += ("Action Edition",)
    kuputool.addResourceType("collection", collections)
    kuputool.addResourceType("linkable", linkables)
    out.write("updated kupu collections and linkables\n")

    # make sure kupu uses uid linking
    if not kuputool.getLinkbyuid():
      table_classnames = kuputool.getTableClassnames()
      html_exclusions = kuputool.getHtmlExclusions()
      style_whitelist = kuputool.getStyleWhitelist()
      class_blacklist = kuputool.getClassBlacklist()
      installBeforeUnload = kuputool.installBeforeUnload()
      parastyles = kuputool.getParagraphStyles()
      filterSourceEdit = kuputool.getFiltersourceedit()
       
      html_exclusions = [{"tags":t,"attributes":a,"keep":True} for t, a in html_exclusions]
      html_exclusions.append({"tags":"","attributes":""})
      
      kuputool.configure_kupu(
        True,
        table_classnames,
        html_exclusions,
        style_whitelist,
        class_blacklist,
        installBeforeUnload=installBeforeUnload,
        parastyles=parastyles,
        filterSourceEdit=filterSourceEdit
      )
      out.write("Set kupu to link by uids.\n")

    applyGenericSetupProfile(self, out)
      
    out.write("Successfully installed %s." % PROJECTNAME)
    return out.getvalue()

    
def uninstall(portal):
    "uninstall properties & kupu registration"
    
    propstool = getToolByName(portal, 'portal_properties')
    try:
        propstool.manage_delObjects(ids=[PROPERTYSHEET,])
    except:
        pass
    
    # remove types from kupu collections & linkables   - if types already removed, pass
    kuputool = getToolByName(portal, 'kupu_library_tool')
    collections = list(kuputool.getPortalTypesForResourceType("collection"))
    linkables = list(kuputool.getPortalTypesForResourceType("linkable"))
    
    try:
        collections.remove("Campaign Action")
        collections.remove("Action Edition")
        collections.remove("Action Step")
        collections.remove("Layout Element")

        kuputool.addResourceType("collection", collections)
    except:
        pass

    try:        
        linkables.remove("Action Edition")
        kuputool.addResourceType("linkable", linkables)
    except:
        pass
    
