from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName


try:
   from Products.CMFCore.permissions import View, ModifyPortalContent
except:
   from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent


try:
   from Products.LinguaPlone.public import *
except ImportError:
   from Products.Archetypes.public import *

from Products.Archetypes.interfaces.base import *

from Products.ATSchemaEditorNG.ParentManagedSchema import ParentManagedSchema
from Products.ATSchemaEditorNG.SchemaEditor import SchemaEditor

from schemas import PersonSchema, OrganizationSchema

__all__ = ["PersonTarget","OrganizationTarget"]

class Person(BaseContent):
   "Person base class"

   schema = BaseContent.schema.copy() + Schema(PersonSchema)

   _at_rename_after_creation = True
   
   def buildTitle(self):
      expr = "%s %s %s %s"
      content = (self.getPrefix(), \
                 self.getGivenname(), \
                 self.getMiddlename(), \
                 self.getFamilyname()
      )

      content = expr % content
      if self.getSuffix():
         content += " %s" % self.getSuffix()

      #if self.getPosition():
      #   content += ", %s" % self.getPosition()

      return content


class PersonTarget(Person):
   "a person target"

   content_icon = "persontarget.png"
   meta_type = portal_type = archetype_name = "Person Target"
   schema = Person.schema
   global_allow=0
   schema['description'].schemata = 'default'

registerType(PersonTarget)


class Organization(BaseFolder):
   "an organization base class"

   schema = BaseFolder.schema.copy() + Schema(OrganizationSchema)


class OrganizationTarget(Organization):
   "organization target"

   meta_type = portal_type = archetype_name = "Organization Target"
   global_allow=0
   allowed_content_types = ["Person Target"]
   content_icon = "organizationtarget.png"

   schema = Organization.schema
   schema['description'].schemata = 'default'

   _at_rename_after_creation = True

registerType(OrganizationTarget)
