import logging

def config_actionrecord_catalog(context):
   "configure action record catalogue"
   logger = logging.getLogger('eCampaigning')
   site = context.getSite()
   catalog = site.actionrecord_catalog
   catalog.title = "the latest submitted action records"

   for field in site.portal_properties.ecampaigning_properties.recent_actions_fields:
      try:
         catalog.manage_addColumn(field)
      except:
         pass

   idxs = (
      ("DateIndex", "getDate"),
      ("FieldIndex", "country"),
      ("FieldIndex", "anonymous"),
      ("ExtendedPathIndex", "path")
   )

   for idx_type, idx_name in idxs:
      try:
         catalog.manage_addIndex(type=idx_type, name=idx_name)
      except:
         pass

   logger.info('eCampaigning action record catalog configured')
