## Script (Python) "newdatafile"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##

from Products.eCampaigning import ProductMessageFactory as _
from Products.eCampaigning.config import AccessEcampaigningDataPermission


ENCODING = context.getCharset() # get site encoding

# PRE-CHECK: use the protection, Luke
context.portal_membership.checkPermission(AccessEcampaigningDataPermission, context.aq_inner)

# PRE-CHECK: nothing yet?
if context.getRecordCount() == 0:
   psm = _("dataexport_error_no_data")
   context.REQUEST.RESPONSE.redirect("view?portal_status_message=%s" % psm)
   return

# we assume that content is stored using site encoding.
#DECODERS = ("ascii","iso8859-1","cp1252")

textmarker = '"'
separator = ','
replacechar = "'"
escapechar = None

# The filename is generated from GMT timezone
zone = "GMT"
dt = DateTime()
n = context.getName().replace(' ', '_')
nameparts = (n, dt.yy(), dt.mm(), dt.dd())
filename = '_'.join(nameparts) + ".csv"

fields = ("id","datetime", "givenname","familyname","emailaddress","receive_updates",
          "streetaddress","postalcode","city","country","name_df",
          "origin_url","entry_url","onsite_origin_url","tracked_medium","tracked_source",
          "tracked_content","tracked_name","tracked_person","tracked_terms",
          "user_agent_language","user_agent","ip_address",
          "messagesubject","message"
         )


# the RESPONSE
RESPONSE = context.REQUEST["RESPONSE"]
RESPONSE.setHeader('Cache-Control', "max-age=0,no-cache,no-store")
RESPONSE.setHeader('Pragma', 'no-cache')
RESPONSE.setHeader('Expires', '-1')
RESPONSE.setHeader('Content-type', 'application/vnd.ms-excel;charset="%s"' % ENCODING)
RESPONSE.setHeader('Content-Disposition','attachment;filename=%s' % filename)

# Construct the CSV headers
line = []
for f in fields:
   headertranslation = context.translate(_("header_dataexport_record_"+f))
   line.append("%s%s%s" % (textmarker, headertranslation, textmarker))
headers = separator.join(line)
headers = headers.encode(ENCODING)

# write headers - note that in zope2, this triggers chunked transfer when other conditions are met 
# see for example http://mail.zope.org/pipermail/zope3-dev/2005-December/016794.html

RESPONSE.write(headers+"\n")
RESPONSE.flush()

for r in context.getRecords():
   record = r.aq_inner.getFieldsAsText(
      fields,
      separator=separator,
      textmarker=textmarker,
      replacechar=replacechar,
      escchar=escapechar,
      decoders=None,
   )
   RESPONSE.write(record + "\r\n")
   RESPONSE.flush()

return
