## Script (Python) "localizedCountryVocabulary"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=languagecode=None
##title= languagecode -> countrylist in that language
##

from Products.CMFCore.utils import getToolByName

propstool = getToolByName(context,"portal_properties")
langtool = None
try:
   langtool = getToolByName(context,"portal_languages")
except:
   pass

countrydata = propstool["country_lists"]
siteprops = propstool["site_properties"]

# PLT stores preferred language in REQUEST["LANGUAGE"]?
# Take parameter or PLT setting -> if no localization, get list in site language

languagecode = languagecode or context.REQUEST.get("LANGUAGE") or ""
havelocalization = hasattr(countrydata,languagecode)

# Fall back to site default language; list in that language must exist!
if not havelocalization:
   if langtool:
      languagecode = langtool.getDefaultLanguage()
   else: 
      languagecode = siteprops.default_language

countrylist = getattr(countrydata,languagecode)

vocabulary = []

# The outcommented code here would add some "probable countries" to the top
# names = context.countriesForBrowserLanguage()

# "Guess" the country
ccode = context.countryFromBrowserLanguage(languagecode)
cname = ""

for countryline in countrylist:
   countrycode, countryname = countryline.split('|')
   countrycode = countrycode.strip()
   countryname = countryname.strip()
   vocabulary.append((countrycode, countryname))

   #handle "en", "es", "pt" etc. languages spoken widely
   #if countrycode in names:
   #   names[countrycode] = countryname

   if countrycode == ccode:
      cname = countryname
      
#for k in names:
#   vocabulary.insert(0,(k,names[k]))

vocabulary.insert(0,(ccode, cname))

return tuple(vocabulary)
