## Script (Python) "step_runtasks.cpy"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##bind state=state
##parameters=
##title= moves to next step
##

from Products.eCampaigning import ProductMessageFactory as _

# SETUP
state.set(errors={}, status="success")
session = context.REQUEST.SESSION
try:
   stepid = session["stepid"]
except:
   msg = _("session_expiry_msg")
   xlation = context.translate(msg, domain="ecampaigning")
   state.set(portal_status_message=xlation)
   state.setNextAction("traverse_to:string:session_timeout_view")
   return state

step = getattr(context, stepid)
render_template = "action_edition_step_view"

# PERFORM TASKS
tasks = step.getStep_tasks()
for t in tasks:
   state = getattr(step, t)(state)
   if state.status == "failure":
      try:
         del session["record_path"]
      except:
         pass
      return state

# PROCEED TO NEXT STEP
next_step_id = step.getNextStepId()
next_step_path = '/'.join((context.absolute_url(), render_template, next_step_id))
session["stepid"] = next_step_id
state.setNextAction("redirect_to:string:%s" % next_step_path)

if context.portal_workflow.getInfoFor(context, "review_state") != "published":
   msg = _("msg_action_test_mode")
   xlation = context.translate(msg, domain="ecampaigning")
   state.set(portal_status_message=xlation)

return state
