## Controller Python Script "steptask_emailtargets"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=state
##title=Email action targets
##

from Products.eCampaigning.util import expand_relative_urls

TARGET_EMAIL_ENCODING = "utf-8"

action = context.aq_parent
recordcontainer = action.records
record_path = context.REQUEST.SESSION['record_path']
record = context.restrictedTraverse(record_path)

targets = action.getTargets() # todo: get stuff from catalog, not the live objects...context.portal_catalog(UID=targetUIDs)
targets = ["%s <%s>" % (t.Title(), t.getEmailaddress()) for t in targets]

msg_tmpl = action.getMessagetemplate()
tmpl_msgtype = msg_tmpl.getField("text").getContentType(msg_tmpl)

if tmpl_msgtype == "text/plain":
   msg = record.getMessage(mimetype="text/plain")
else:
   msg = record.getMessage()
   msg = expand_relative_urls(msg, context.REQUEST.BASE0)

# add signature ie. "Petri, Finland"
signature = record.getFullName() + ", " + context.localizedCountryName(record.country)
msg += "\n\n" + signature

supporter_email = "%s <%s>" % (record.getFullName(), record.emailaddress)
message_subject = record.getSubject()

# Email send to targets
for a in targets:
   try:
      context.MailHost.secureSend(
         msg,
         a,
         supporter_email,
         subject=message_subject,
         subtype=tmpl_msgtype.split('/')[1],
         charset=TARGET_EMAIL_ENCODING
      )
   except Exception, e:
      errmsg="Email to %s with subject '%s' failed: %s" % (a, message_subject,e)
      return state.set(status="failure", portal_status_message=errmsg)
   
return state
