## Controller Python Script "steptask_emailtargets"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=state
##title=Email action targets
##
from Products.eCampaigning import ProductMessageFactory as _
from Products.eCampaigning.util import expand_relative_urls

TARGET_EMAIL_ENCODING = context.portal_properties["site_properties"].default_charset
HTML_EMAIL = False

action = context.aq_parent
recordcontainer = action.getRecordContainer()
actiontype = action.getActiontype()
record_path = context.REQUEST.SESSION['record_path']
record = context.restrictedTraverse(record_path)

#editablemsg = action.getAction_message_modifiable() <-- editablemsg not used?

msg_tmpl = action.getMessagetemplate()
email_tmpl = action.getThankyouemail()


# CHECK FOR EXISTENCE OF TEMPLATES
if not (msg_tmpl or email_tmpl):
   errmsg = "Action not configured properly: check that the action templates exist & are filled in"
   return state.set(status="failure", portal_status_message=errmsg)


# DETERMINE FORMATS

HTML_EMAIL = HTML_MSG = SEND_HTML = False

email_tmpl_format = email_tmpl.getField("text").getContentType(email_tmpl)
if "html" in email_tmpl_format:
   HTML_EMAIL = True
if "html" in msg_tmpl.getField("text").getContentType(msg_tmpl):
   HTML_MSG = True

if HTML_EMAIL or HTML_MSG:
   SEND_HTML = True


if HTML_EMAIL:
   email_msg = email_tmpl.getText(mimetype="text/x-html-safe")
else:
   email_msg = email_tmpl.getText(mimetype="text/plain")


# APPEND A COPY OF THE MESSAGE (optionally) 
if context.getThankyouemail_includemessage():
   
   # set divider
   msgid = "label_%s_thanksemail_copydivider" % context.sanitizedTypeName(typename=actiontype)
   i18ndivider = context.translate(_(msgid), domain="ecampaigning").encode(TARGET_EMAIL_ENCODING)
   divider = "\n\n%s\n\n" % i18ndivider

   message_subject = record.getSubject()

   # If thanks message is plaintext, transform action message to plaintext if it's HTML
   # If thanks message is HTML, do not transform plaintext action message to HTML
   # (instead do manual inclusion, see below)

   # add divider & copy of message
   if HTML_EMAIL:
      divider = "<br/>%s<br/>" % divider
      if HTML_MSG:
         attach_msg = record.getMessage(mimetype="text/x-html-captioned")
      else:
         attach_msg = "<pre>%s</pre>" % record.getMessage(mimetype="text/plain")
      email_msg += "%s\n<p><b>%s</b></p>\n%s" % (divider, message_subject, attach_msg)
   else:
      attach_msg = record.getMessage(mimetype="text/plain")
      email_msg += "\n\n%s\n\n%s\n\n%s" % (divider, message_subject, attach_msg)


if SEND_HTML:

   # Kupu > 1.3.9 uses relative paths so need to turn them into absolute
   email_msg = expand_relative_urls(email_msg, context.REQUEST.BASE0)

   # wrap in HTML stanza
   email_msg = "<html><body>%s</body></html>" % email_msg


# SEND THE MESSAGE
email_subject = email_tmpl.getMessagetitle()

try:
   context.MailHost.secureSend(
      email_msg,
      "%s <%s>" % (record.getFullName(), record.emailaddress), # to
      "%s <%s>" % (action.getThankyouemailname(), action.getThankyouemailfrom()), # from
      subject=email_subject,
      subtype=email_tmpl_format.split('/')[1],
      charset=TARGET_EMAIL_ENCODING,
   )
except Exception, e:
   errmsg = "email to %s with subject '%s' failed: %s" % (record.emailaddress, email_subject, e)
   return state.set(status="failure", portal_status_message=errmsg)

   
return state
