## Controller Python Script "steptask_storetrackinginfo"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=state
##title=Store user tracking information
##


# TRACKING INFO IS STORED BOTH IN THE RECORD AND IN SESSION

from Products.PythonScripts.standard import url_unquote

REQUEST = context.REQUEST
session = REQUEST.SESSION

record_container = context.getRecordContainer()

try:
   record_path = session["record_path"]
   record = context.restrictedTraverse(record_path)
except:
   from Products.eCampaigning import ProductMessageFactory as _
   errmsg = _("step_error_no_record")
   return state.set(status="failure", portal_status_message=errmsg)
   
# useragent and -ip address; try non-proxied request variable, then squid-proxied, finally apache-proxied
user_ip = REQUEST.get("X_FORWARDED_FOR") or REQUEST.get("HTTP_X_FORWARDED_FOR") or REQUEST.get("REMOTE_ADDR")
record.manage_addProperty("ip_address", user_ip, "string")

record.manage_addProperty("user_agent", REQUEST["HTTP_USER_AGENT"], "string")
record.manage_addProperty("user_agent_languages", REQUEST["HTTP_ACCEPT_LANGUAGE"], "string")

# time and date
record.manage_addProperty("datetime", DateTime(), "date")

# url tracking
record.manage_addProperty("origin_url", session.get('origin_url',''), "string")
record.manage_addProperty("onsite_origin_url", session.get('onsite_origin_url'),"string")

entry_url = session.get("entry_url", "")
record.manage_addProperty("entry_url", entry_url, "string")

# 
# THE URL PARAMETER NAME - ACTION RECORD PARAMETER NAME MAPPING
#
# REF http://www.fairsay.com/labs/standards/AdvocacyTracking
# REF http://www.fairsay.com/labs/ectool/docs/Tracking#query-string-tracking

# NOTE: MAKE SURE TO SYNC THIS LIST WITH THE VALUES of 'mapping' in takeaction.cpy

trackingvars = (
   'tracked_source',
   'tracked_medium',
   'tracked_person',
   'tracked_content',
   'tracked_name'
)

# terms not in above list - needs special handling
terms = "tracked_terms" # sync with takeaction.cpy & util.py
record.manage_addProperty(terms, '\n'.join(session[terms]), "lines")

# process the list
for k in trackingvars:
   record.manage_addProperty(k, session[k], "string")
return state
