## Script (Python) "takeaction"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##bind state=state
##parameters=
##title= action view
##
from Products.eCampaigning import ProductMessageFactory as _
from Products.eCampaigning.util import process_tracking_variables

request = context.REQUEST
session = request.SESSION
response = request.RESPONSE

# The content type that is used to store sign-ups
record_type = "Action Record"

# Clear the record, allowing same PC/browser to be used
try:
   del session["record_path"]
except:
   pass


# Parse tracking variables and put them in session
# REF http://www.fairsay.com/labs/standards/AdvocacyTracking
# REF http://www.fairsay.com/labs/ectool/docs/Tracking#query-string-tracking

entry_url = session.get("entry_url", "")


# THE VALUES OF THIS DICT NEED TO KEEP IN SYNC with any step tasks that handle
# tracking variables

mapping = {
   's':'tracked_source',
   'm':'tracked_medium',
   'p':'tracked_person',
   'c':'tracked_content',
   't':'tracked_terms', # special case, needs to be passed in 'terms' kwarg
   'n':'tracked_name'
}

if '?' in entry_url:
   session.update(process_tracking_variables(entry_url, mapping, terms="tracked_terms"))
else:
   vars = dict([(n,None) for n in mapping.values()])
   vars["tracked_terms"] = ()
   session.update(vars)

# Set on-site referral/origin URL

#if "onsite_origin_url" not in session.keys():
if request.HTTP_REFERER[:len(request.SERVER_URL)] == request.SERVER_URL:
   session["onsite_origin_url"] = request.HTTP_REFERER
else:
   session["onsite_origin_url"] = "direct"

# Make sure we're not cached!
response.setHeader('Expires', '-1')
response.setHeader('Pragma', 'no-cache')
response.setHeader('Cache-Control', 'no-cache')

# TODO: remove sanitizedTypeName if it's used nowhere!

try:
   firststep = context.getFirstStepId()
except:
   msg = _("warning_no_steps")
   xlation = context.translate(msg, domain="ecampaigning")
   return state.set(status='failure', portal_status_message=xlation)

session["stepid"] = firststep
#state.setKwargs({"persistent_stepid":firststep})
state.setNextAction('traverse_to:string:action_edition_step_view/%s' % firststep)


if context.portal_workflow.getInfoFor(context, "review_state") != "published":
   msg = _("msg_action_test_mode")
   xlation = context.translate(msg, domain="ecampaigning")
   #context.plone_utils.addPortalMessage(msg)
   return state.set(status="success", portal_status_message=xlation)

return state
